peg::parser!
(
    grammar calc() for str
    {
        pub rule eval() -> i64 
            = expr()
    
        rule expr() -> i64
            = left_value : term() "+" right_value : expr() { left_value + right_value }
            / left_value : term() "-" right_value : expr() { left_value - right_value }
            / term()

        rule term() -> i64
            = left_value : value() "*" right_value : term() { left_value * right_value }
            / left_value : value() "/" right_value : term() { left_value / right_value }
            / value : value()

        rule value() -> i64
            = number()
            / "(" value : expr() ")" { value }
        
        rule number() -> i64
            = value : $(['0'..='9']+) 
            { value.parse().unwrap() }
    }
);

fn main()
{
    println!("{}", calc::eval("10+20*30").unwrap());
    println!("{}", calc::eval("(10+20)*30").unwrap());
    println!("{}", calc::eval("10/20-30").unwrap());    
}